import java.util.*;

public class IntegerDuplicateDeleter extends DuplicateDeleter<Integer>{
    public IntegerDuplicateDeleter(Integer [] array){
        super(array);
    }

    public Integer[] removeDuplicates(int maxNumberOfDuplications){
        Integer [] newArray = new Integer[array.length];
        int newArrayIndex =0;
        for (Integer i: array){
            int integerCount = 0;
            for (Integer j: array){
                if (i==j){
                    integerCount = integerCount +1;
                }
            }
            if (integerCount < maxNumberOfDuplications){
                newArray[newArrayIndex] = i;
                newArrayIndex = newArrayIndex + 1;
            }
        }
        Integer [] finalArray = Arrays.copyOf(newArray, newArrayIndex);
        return finalArray;
    }

    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications){
        Integer [] newArray = new Integer[array.length];
        int newArrayIndex = 0;
        for (Integer i : array){
            int integerCount = 0;
            for (Integer j : array){
                if (i == j){
                    integerCount = integerCount + 1;
                }
            }
            if (integerCount != exactNumberOfDuplications){
                newArray[newArrayIndex] = i;
                newArrayIndex = newArrayIndex + 1;
            }
        }
        Integer[] finalArray = new Integer [newArrayIndex]; 
        finalArray = Arrays.copyOf(newArray, newArrayIndex);
        return finalArray;
    }
}